<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_referral".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderReferral".
 *
 * Columns in table "provider_referral" available as properties of the model,
 * followed by relations of table "provider_referral" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id_from
 * @property integer $provider_id_to
 * @property integer $provider_id_from_accepted
 * @property integer $provider_id_to_accepted
 * @property string $date_added
 *
 * @property Provider $providerIdFrom
 * @property Provider $providerIdTo
 */
abstract class BaseProviderReferral extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_referral';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('provider_id_from, provider_id_to, date_added', 'required'),
            array('provider_id_from, provider_id_to, provider_id_from_accepted, provider_id_to_accepted',
                'numerical', 'integerOnly' => true),
            array('provider_id_from_accepted, provider_id_to_accepted', 'default', 'setOnEmpty' => true,
                'value' => null),
            array('id, provider_id_from, provider_id_to, provider_id_from_accepted, provider_id_to_accepted, '
                . 'date_added', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'providerIdFrom' => array(self::BELONGS_TO, 'Provider', 'provider_id_from'),
            'providerIdTo' => array(self::BELONGS_TO, 'Provider', 'provider_id_to'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id_from' => Yii::t('app', 'Provider Id From'),
            'provider_id_to' => Yii::t('app', 'Provider Id To'),
            'provider_id_from_accepted' => Yii::t('app', 'Provider Id From Accepted'),
            'provider_id_to_accepted' => Yii::t('app', 'Provider Id To Accepted'),
            'date_added' => Yii::t('app', 'Date Added'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id_from', $this->provider_id_from);
        $criteria->compare('provider_id_to', $this->provider_id_to);
        $criteria->compare('provider_id_from_accepted', $this->provider_id_from_accepted);
        $criteria->compare('provider_id_to_accepted', $this->provider_id_to_accepted);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderReferral|ProviderReferrals', $n);
    }

}
